*! 0.1.1 - jeremy freese - 6/15/05 - change refcat() to base()
*  0.1.0 - jeremy freese - 6/11/05

program define asprvalue

preserve

	version 9

	syntax [, x(passthru) Cat(string) Base(string) Save Diff Rest(string) BRief  Full]


	tempname b
	mat `b' = e(b)
	local allnames : colnames `b'
/*
*CHECK
di "`allnames'"
*/

	* make list of case-specific variables
	foreach var of local allnames {
		local i = index("`var'", "X")
		if `i' != 0 {
		* is it an alternativeXcase-specific-variable interaction?
			local temppreX = substr("`var'", 1, `i'-1)
			local temppostX = substr("`var'", `i'+1, .)
			* assume that preX are all cats -- TO DO: insert check?
			local catslist "`catslist' `temppreX'"
			local isAxA "no"
			foreach var2 of local allnames {
				if "`temppostX'"=="`var2'" | "`temppostX'"=="`base'" {				
					local isAxA "yes"
					local aXalist "`aXalist' `var'"
				}
			}
		* is it an alternativeXalternative interaction?
			if "`isAxA'" == "no" {
				local aXclist "`aXclist' `var'"
				local csvlist "`csvlist' `temppostX'"
			}
		}
	}
	
	* if cat is specified, that is the list of categories
	if "`cat'"!= "" {
		local catslist = "`cat'"
	}
	
	local catslist : list uniq catslist
	local ncatsmin1 : word count `catslist'
	local numcats = `ncatsmin1' + 1
	local csvlist : list uniq csvlist

	local asvlist : list allnames - aXclist
	local asvlist : list asvlist - catslist
	local asvlist : list asvlist - aXalist

	/*
	* CHECK
	di "altXasv interactions: `aXalist'"
	di "altXcase interactions: `aXclist'"
	di "alternatives: `catslist'"
	di "altspec vars: `asvlist'"
	di "casespec vars: `csvlist'"
	di "number of alternatives `ncatsmin1'"
	*/

	* decode x() values
	tokenize `x', parse("()")
	local x "`3'"
	tokenize `x', parse(" =")
	while "`1'" != "" & "`2'" != "" {

		capture confirm number `3'
		if _rc == 0 {
			* TO DO: check that `1' is alternative-specific variables
			forvalues i = 1(1)`numcats' {
				local iplus1 = `i' + 1
				confirm number ``iplus1'' 
				local V`1'V`i' = ``iplus1''
			}
			macro shift `iplus1'
		}

		else {
			local V`1' = `2'
			macro shift 2
		}
	}


	* HANDLE REST OPTION
	
	* rest() = mean by default
	if "`rest'" == "" {
		local rest "mean"		
	}
	*check that rest option includes an allowable option
	if "`rest'" != "mean" & "`rest'" != "asmean" {
		di as err "rest(`rest') not allowed"
		error 999
	}

	foreach var of local csvlist {
		if "`V`var''" == "" {
			if "`rest'" == "mean" | "`rest'" == "asmean" {
				qui su `var' if e(sample) == 1
				local V`var' = r(mean)
			}
		}
	}

	foreach var of local asvlist {
		if "`V`var''" == "" & "`V`var'V1'" == "" {
			if "`rest'" == "mean" {
				qui su `var' if e(sample) == 1
				forvalues i = 1(1)`numcats' {
					local V`var'V`i' = r(mean)
				}
			}
			if "`rest'" == "asmean" {
				tempname refdum
				* this variable will equal 1 for only those cases that indicate base
				qui gen `refdum' = 1 if e(sample) == 1
				local i = 1
				foreach catname of local catslist {
					qui su `var' if `catname' == 1 & e(sample) == 1					
					local V`var'V`i' = r(mean)
					* turn off refdum for variables indicating category
					qui replace `refdum' = 0 if `catname' == 1 & e(sample) == 1					
					local i = `i' + 1
				}
				* use refdum to get mean for reference category
				qui su `var' if `refdum' == 1 & e(sample) == 1					
				local V`var'V`i' = r(mean)
			}
		}
	}

	* add observations to bottom of dataset

	local N = _N
	local refobs = `N' + 1 // refobs is the reference number of the first added obs
	local newn = `refobs'+`ncatsmin1'

	qui set obs `newn'
	capture drop _addedobs
	qui gen _addedobs = 1 if _n >= `refobs'

	foreach cat of local catslist {
		local obs = `refobs'
		foreach cat2 of local catslist {

			* set dummy variables indicating which row is which alternative
			qui replace `cat' = 1 in `obs' if "`cat'" == "`cat2'"
			qui replace `cat' = 0 in `obs' if "`cat'" != "`cat2'"

			* set values for aXc interactions
			foreach csvar of local csvlist {
				qui replace `cat'X`csvar' = `V`csvar'' in `obs' if "`cat'" == "`cat2'"
				qui replace `cat'X`csvar' = 0 in `obs' if "`cat'" != "`cat2'"
			}

			local obs = `obs' + 1
		}

		* set all alternative dummies to zero for row indicating reference category
		qui replace `cat' = 0 in `obs'

		* set all aXc to zero for row corresponding to reference category
		foreach csvar of local csvlist {
			qui replace `cat'X`csvar' = 0 in `obs'
		}

	}

	* set values for alternative-specific variables
		foreach alt of local asvlist {
			if "`V`alt''" != "" { 
				qui replace `alt' = `V`alt'' in `refobs'/`newn'
			}
			else {
				forvalues i = 1(1)`numcats' {
					local obs = `refobs' + `i' - 1
					qui replace `alt' = `V`alt'V`i'' in `obs'
				}
			}
		}

	* set values for aXa interactions
		foreach var of local aXalist {
			local i = index("`var'", "X")
			local temppreX = substr("`var'", 1, `i'-1)
			local temppostX = substr("`var'", `i'+1, .)
			qui replace `var' = `temppreX'*`temppostX' if _addedobs == 1						
		}

	* generate predicted probabilities
		tempname prob
		qui predict `prob' if _addedobs == 1

		* reference category name
		if "`base'" == "" {
			local base = "base"	
		}

* DISPLAY RESULTS

* display predicted probabilities

	local obs = `refobs'
	capture mat drop asprvres
	foreach cat of local catslist {
		tempname tmpprob
		sca `tmpprob' = `prob'[`obs']

		mat asprvres = (nullmat(asprvres) \ `tmpprob')

		local obs = `obs' + 1
	}
	sca `tmpprob' = `prob'[`obs']
	mat asprvres = (nullmat(asprvres) \ `tmpprob')

	mat rownames asprvres = `catslist' `base'
	mat colnames asprvres = prob
	

	if "`diff'" != "" {
		mat changesav = asprvres - _ASPRVsav
		tempname display
		mat `display' = (asprvres, _ASPRVsav, changesav)
		mat colnames `display' = Current Saved Diff
		mat list `display', noh
	}
	else {
		mat list asprvres, noh
	}
	
* display base values for case-specific variables

	if "`csvlist'" != "" {
		capture mat drop csvals
		foreach var of local csvlist {
			mat csvals = (nullmat(csvals) , `V`var'')
		}
		mat colnames csvals = `csvlist'
		mat rownames csvals = x=

		if "`brief'" == "" {
			di _n as txt "case-specific variables"

			if "`diff'" != "" {
				mat changecsv = csvals - _ASPRVcsv
				tempname displaycsv
				mat `displaycsv' = (csvals \ _ASPRVcsv \ changecsv)
				mat rownames `displaycsv' = Current Saved Diff
				mat list `displaycsv', noh
			}
			else {
				mat list csvals, noh
			}
		}

	}

* display base values for alternative-specific variables

	if "`asvlist'" != "" {
		capture mat drop asvals
		foreach alt of local asvlist {
		capture mat drop _tmp
			if "`V`alt''" != "" { 
				mat _tmp = J(1, `numcats', `V`alt'')
			}
			else {
				forvalues i = 1(1)`numcats' {
					mat _tmp = (nullmat(_tmp) , `V`alt'V`i'')
				}
			}
			mat asvals = (nullmat(asvals) \ _tmp)
		}
		mat rownames asvals = `asvlist'
		mat colnames asvals = `catslist' `base'

		if "`brief'" == "" {
			di _n as txt "alternative-specific variables"

			if "`diff'" != "" {

				tempname curasv
				mat `curasv' = asvals

				tempname savedasv
				mat `savedasv' = _ASPRVasv
				mat changeasv = asvals - `savedasv'

				mat roweq `curasv' = Current
				mat roweq `savedasv' = Saved
				mat roweq changeasv = Dif

				tempname displayasv
				mat `displayasv' = (`curasv' \ `savedasv' \ changeasv)
				mat list `displayasv', noh
			}
			else {
				mat list asvals, noh
			}
		}

	}

* display all added observations and values if desired

	if "`full'" != "" {
		list `allnames' if _addedobs == 1, noobs
	}

	if "`save'" != "" {
		mat _ASPRVsav = asprvres

		mat _ASPRVcsv = csvals
		mat _ASPRVasv = asvals
	}

restore

end
