set more off
capture log close
log using fitstat_all, replace

* jsl 10Jun2005 - fitstat 1.7.5 with fixed formatting

/*
global test = 1
*/

run fitstat.ado
which fitstat

global test = 0

//  clogit 1.7.5 10Jun2005 - ok
qui spex clogit
    fitstat, save
    fitstat, dif

//  tobit 1.7.5 10Jun2005 - ok
qui spex tobit
    fitstat, save
qui tobit jobcen fem phd fel art cit, ll(1) nolog
    fitstat, dif
qui spex tobit
    fitstat, save bic
qui tobit jobcen fem phd fel art cit, ll(1) nolog
    fitstat, dif bic

//  cnreg 1.7.5 10Jun2005 - ok
qui spex cnreg
    fitstat, save bic
qui cnreg testscor bymomed black hispanic, censored(censor)
    fitstat, dif bic
qui spex cnreg
    fitstat, save
qui cnreg testscor bymomed black hispanic, censored(censor)
    fitstat, dif

// binary 1.7.5 10Jun2005 - ok
qui spex logit
    fitstat, save
qui logit lfp-wc
    fitstat, dif
qui spex logit
    fitstat, bic save
qui logit lfp-wc
    fitstat, bic dif

qui spex probit
    fitstat, save
qui probit lfp-wc
    fitstat, dif
qui spex probit
    fitstat, bic save
qui probit lfp-wc
    fitstat, bic dif

qui spex cloglog
    fitstat, save
qui cloglog lfp-wc
    fitstat, dif
qui spex cloglog
    fitstat, bic save
qui cloglog lfp-wc
    fitstat, bic dif

// nominal 1.7.5 10Jun2005 - ok
qui spex mlogit
    fitstat, save
qui mlogit occ ed exper, base(5) nolog
    fitstat, dif
qui spex mlogit
    fitstat, save bic
qui mlogit occ ed exper, base(5) nolog
    fitstat, dif bic
* mprobit for nominal outcome
suse nomocc2
qui mprobit occ white ed exper, base(5)
    fitstat, save
qui mprobit occ ed exper, base(5)
    fitstat, dif
* slogit
use e:\spostdata\ordwarm2, clear
slogit  warm yr89 male white age ed prst, nolog
    ereturn list
    fitstat, save
slogit  warm  male white age ed prst, nolog
    ereturn list
    fitstat, dif

// count 1.7.5 10Jun2005 - ok
qui spex poisson
    fitstat, save
qui poisson art mar phd ment, nolog
    fitstat, dif
qui spex poisson
    fitstat, save bic
qui poisson art mar phd ment, nolog
    fitstat, dif bic

qui spex nbreg
    fitstat, save
qui nbreg art mar phd ment, nolog
    fitstat, dif
qui spex nbreg
    fitstat, save bic
qui nbreg art mar phd ment, nolog
    fitstat, dif bic

qui spex zip
    fitstat, save
qui zip art mar phd ment,  inf(mar-ment) nolog
    fitstat, dif
qui spex zip
    fitstat, save bic
qui zip art mar phd ment,  inf(mar-ment) nolog
    fitstat, dif bic

qui spex zinb
    fitstat, save
qui zinb art mar phd ment, inf(mar-ment) nolog
    fitstat, dif
qui spex zinb
    fitstat, save bic
qui zinb art mar phd ment,  inf(mar-ment) nolog
    fitstat, dif bic

* ztp and ztnb
suse couart2
qui ztp art phd ment if art!=0, nolog
    fitstat, save
qui ztp art mar phd ment if art!=0, nolog
    fitstat, dif
qui ztp art phd ment if art!=0, nolog
    fitstat, save bic
qui ztp art mar phd ment if art!=0, nolog
    fitstat, dif bic

* ztnb
suse couart2
qui ztnb art phd ment if art!=0, nolog
    fitstat, save
qui ztnb art mar phd ment if art!=0, nolog
    fitstat, dif
qui ztnb art phd ment if art!=0, nolog
    fitstat, save bic
qui ztnb art mar phd ment if art!=0, nolog
    fitstat, dif bic

// regress 1.7.5 10Jun2005 - ok
xintreg
    fitstat, save
intreg minscor maxscor bydaded hispanic, nolog
    fitstat, dif force
xintreg
    fitstat, save bic
intreg minscor maxscor bydaded hispanic, nolog
    fitstat, dif bic force

qui spex reg
    fitstat, save
qui regress job fem ment fel art cit
    fitstat, dif
qui spex reg
    fitstat, save bic
qui regress job fem ment fel art cit
    fitstat, dif bic


// ordered 10Jun2005 - ok

qui spex ologit
    fitstat, save
qui ologit warm yr89 male white
    fitstat, dif
qui spex ologit
    fitstat, save bic
qui ologit warm yr89 male white
    fitstat, dif bic

qui spex oprobit
    fitstat, save
qui oprobit warm yr89 male white
    fitstat, dif
qui spex oprobit
    fitstat, save bic
qui oprobit warm yr89 male white
    fitstat, dif bic

log close
